local frame = CreateFrame("FRAME", "PilgrimRogues")
local ach = {}
local faction = UnitFactionGroup("Player")
local function eventHandler(self, event, ...)
	for i = 1, 8 do 
		local criteriaString, _, completed = GetAchievementCriteriaInfo(3559,i)
		local class = string.gsub(criteriaString, " Rogue", "")
		if not completed then tinsert(ach, class) end
	end
end
frame:SetScript("OnEvent", eventHandler)

local origGameTooltip_UnitColor = GameTooltip_UnitColor
local newGameTooltip_UnitColor = function(...)
	local unit = ...
	
	if (select(2,UnitClass(unit)) == "ROGUE" and UnitIsPlayer(unit)) then
		for k,race in pairs(ach) do
			if race == UnitRace(unit) then
				local name = GetUnitName(unit, false)
				
				print("PilgrimRogues : "..name, race)
				if faction == UnitFactionGroup(unit) and not GetRaidTargetIndex(unit) then 
					SetRaidTarget(unit,1)
				end
				if GetMacroInfo("PilgrimRogues") and not InCombatLockdown() then
					EditMacro("PilgrimRogues", "PilgrimRogues", 12, "/tar "..name, true, true)
				end
			end
		end
	end
	
	return origGameTooltip_UnitColor(unit)
end

local pr = false

SLASH_ADDONNAME1 = "/pilgrimrogues"
SlashCmdList.ADDONNAME = function()
	if not pr then
		pr = true
		GameTooltip_UnitColor = newGameTooltip_UnitColor
		frame:RegisterEvent("CRITERIA_UPDATE")
		eventHandler()
		print("PilgrimRogues : Targeting macro is ready, mouseover some rogues now !")
		if not GetMacroInfo("PilgrimRogues") then
			CreateMacro("PilgrimRogues", 12, "", true, true)
		end
	else
		pr = false
		GameTooltip_UnitColor = origGameTooltip_UnitColor
		frame:UnregisterEvent("CRITERIA_UPDATE")
		
		if GetMacroInfo("PilgrimRogues") then
			DeleteMacro("PilgrimRogues")
		end
	end
end